/*
 *     
 */
#include <stdio.h>
#include <strings.h>
#include <string.h>
#include "strutils.h"

// Kontrolu, cxu sekvanta litercxeno egalas al sxablono
int match(char **p, char *pat) {
  if (strncmp(*p,pat,strlen(pat))==0) {
    (*p)+=strlen(pat);
    return 1;
  }
  return 0;
} //match

// Forigu n literojn el litercxeno
void del(char *p, int n) {
  register char *pp;
  if (n==0) return;
  pp=p+n;
  if (strlen(p)>n)
    while (*pp)
      *p++=*pp++;
  *p=0;
} //del

// Inkludu cxenon a en litercxenon
void ins(char *p, char *a) {
  register char *pp;
  int n=strlen(a);
  if (n==0) return;
  pp=p+strlen(p);
  while (pp>=p) {
    pp[n]=*pp;
    pp--;
  }
  while (*a)
    *p++=*a++;
} //ins

// Anstatauxigu a per b en litercxeno s
char *rep(char *s, char *a, char *b) {
  register char *p=strstr(s,a);
  if (p==NULL) return NULL;
  del(p,strlen(a));
  ins(p,b);
  return p;
} //rep

void uni_decode (char *s) {
  while (rep(s,"&#264;","Cx"));
  while (rep(s,"&#265;","cx"));
  while (rep(s,"&#284;","Gx"));
  while (rep(s,"&#285;","gx"));
  while (rep(s,"&#292;","Hx"));
  while (rep(s,"&#293;","hx"));
  while (rep(s,"&#308;","Jx"));
  while (rep(s,"&#309;","jx"));
  while (rep(s,"&#348;","Sx"));
  while (rep(s,"&#349;","sx"));
  while (rep(s,"&#364;","Ux"));
  while (rep(s,"&#365;","ux"));
} //uni_decode

static char *upper="ABCDEFGHIJKLMNOPQRSTUVWXYZŨ";
static char *lower="abcdefghijklmnopqrstuvwxyz";

void toLower(char *s) {
  register char *p;
  for (; *s; s++) {
    p=strchr(upper,*s);
    if (p) *s=lower[p-upper];
    if (*s=='') *s='';
  }
} //toLower

int checkbrc(char *w, char *w1, char *w2) {
  register char *p1,*p2;

  for (p1=w1, p2=w2; *w; w++) {
    if (*w!='(' || w[1]=='*')
      *p1++ = *p2++ = *w;
    else
      for (w++ ;*w && *w!=')'; w++)
        *p1++ = *w;
      if (*w==0) break;
  }
  *p1 = *p2 =0;
  return (p1-w1)==(p2-w2);
} //checkbrc

// Komparu vorton kun sxablono
int wcmp(char *pat, char *word) {
  char w1[MAXLEN],w2[MAXLEN];
  if (checkbrc(word,w1,w2))
    return wcmp0(pat,word);
  else
    return wcmp0(pat,w1)||wcmp0(pat,w2);
} //wcmp

int wcmp0 (char *pat, char *word) {
  register char *p, *w;
  p=pat; w=word;
  for(;;) {
    if (*p=='*') {  //jxokero
      if (*w=='x') return 0;     //x-oj estas kromsignoj!
      if (p[1]==0) return 1;     //fino de sxablono
      for (; *w; w++)
        if (wcmp0(p+1,w)) return 1;
          return 0;
    }
    else if (*p!=*w)
      return 0;
    p++; w++;
    if (*p==0) break;
  }
  if (*p==*w) return 1;
  else return 0;
} //wcmp0
